#pragma once
#include <tchar.h>
#include <windows.h>

#define JPK_API __declspec(dllimport) __stdcall

typedef void (__stdcall *PROGRESS_PROC)(void* SessionID, __int64 FilesCount, __int64  CurrentFile, __int64  FileSize, __int64  CurrentPosition, int* UserBreak, int Err, Wchar* ErrMsg);
typedef void (__stdcall *FINISH_PROC)(void*  SessionID, Wchar* ReferenceNumber, int Status, Wchar* StatusText, Wchar* UPO, int UserBreak, int Err,Wchar* ErrMsg);
  
void JPK_API SetLic(WCHAR* licText);
void JPK_API SetLicA(CHAR* licText);

void JPK_API SetPublicKeyFile(WCHAR* KeyFileName, WCHAR* KeyPass);
void JPK_API SetPublicKeyFileA(WCHAR* KeyFileName, WCHAR* KeyPass);
void JPK_API SetCertFile(WCHAR* CertFileNameOdIndex, WCHAR* CertPass);
int JPK_API GetCertCurrentIndex();
int JPK_API ShowCertList(unsigned int ParentHandle);
void JPK_API SetPublicKey(void* Key, int KeySize, WCHAR* KeyPass);
void JPK_API SetCert(void* Cert, int CertSize, WCHAR* CertPass);

int JPK_API SetProgressCaption(void* SessionID, WCHAR* Caption);
void JPK_API SetParentwindowHandle(unsigned int Handle);
void JPK_API InternetSettingsForm(unsigned int ParentHandle);

int JPK_API GetCertyficateCount();
int JPK_API GetCertyficate(int Index, WCHAR** cert);

int JPK_API AddXMLJPK(char* XML, unsigned char DocType, WCHAR* DefFileName = NULL);
int JPK_API AddXMLJPKFile(Wchar* XMLFileName, unsigned char DocType);
LPVOID JPK_API SignSendJPK(int TestMode, PROGRESS_PROC Progress, FINISH_PROC Finish, int SyncFinish);
int JPK_API SignSendJPKAndWait(int TestMode, PROGRESS_PROC Progress, Wchar**ReferenceNumbers);
void JPK_API SignSendBreak(void* SessionID);

void JPK_API WaitForEnd(void* SessionID, WCHAR** ReferenceNumbers);
PWCHAR JPK_API GetReferenceNumbers(WCHAR* SessionID);
int JPK_API GetUPO(int TestMode, WCHAR* ReferenceNumber, WCHAR** UPO, int* Status, WCHAR** statusText);
int JPK_API BreakGetUPO(WCHAR* ReferenceNumber);
void JPK_API JPKGetLastError(WCHAR** ErrText);

int JPK_API FileNameValidate(const WCHAR* FileName, WCHAR** errText);
int JPK_API XMLValidate(const char* XMLData, WCHAR** errText);
int JPK_API XMLFileValidate(const WCHAR* FileName, WCHAR** errText);
void JPK_API XMLValidateBreak();
int JPK_API PrintUPO(WCHAR* UPO, unsigned int ParentHandle);

void JPK_API FinalizeDLL();